Summary: Various compilers (C, C++, Objective-C, Java, ...)
Name: gcc
Version: 2.95.3
Release: 0.71.4sx
Copyright: GPL
Group: Development/Languages
Source: gcc-%{version}.tar.gz
Patch1: gcc-2.95.3-s390.patch
Patch2: gcc-2.95.3-s390-1.patch
Patch3: gcc-2.95.3-s390-2.patch
Patch4: gcc-2.95.3-s390-3.patch
Patch10: gcc-2.95.2-bogushack-s390x.patch
Patch13: gcc-2.95.3-glibc224.patch
Patch14: gcc-2.95.3-libio.patch
Patch17: gcc-2.95.3-cvs.patch
Patch18: gcc-2.95.3-s390-undef.patch
URL: http://gcc.gnu.org
BuildRoot: /var/tmp/gcc-root
Obsoletes: egcs
%ifarch sparc sparc64
Obsoletes: egcs64
%endif
%ifarch sparc sparc64
Requires: binutils >= 2.9.5.0.46
%else
%ifnarch s390
Requires: binutils >= 2.9.5.0.41
%endif
%endif
%{expand: %%{global} _gcc_is_%{_target_cpu} %%{nil}}
%{?_gcc_is_sparc: %global gcc_target_platform sparc64-redhat-linux}
%{!?_gcc_is_sparc: %global gcc_target_platform %{_target_platform}}
Requires: cpp = %{version}
Requires: glibc-devel
Prereq: /sbin/install-info
ExcludeArch: ia64

%description
The gcc package contains the GNU Compiler Collection: cc and gcc. You'll need
this package in order to compile C/C++ code.

%package c++
Summary: C++ support for gcc
Obsoletes: egcs-c++
Group: Development/Languages
Requires: gcc = %{version}
Requires: cpp = %{version}
Requires: libstdc++ = %{version}
Requires: libstdc++-devel = %{version}

%description c++
This package adds C++ support to the GNU C compiler. It includes support
for most of the current C++ specification, including templates and
exception handling. It does include the static standard C++
library and C++ header files; the library for dynamically linking
programs is available separately.

%package -n libstdc++
Summary: GNU c++ library
Group: System Environment/Libraries
Provides: libstdc++-devel
Obsoletes: gcc-libstdc++
Obsoletes: libg++

%description -n libstdc++
The libstdc++ package contains a snapshot of the GCC Standard C++
Library v3, an ongoing project to implement the ISO 14882 Standard C++
library.

%package objc
Summary: Objective C support for gcc
Group: Development/Languages
Requires: gcc = %{version}
Obsoletes: egcs-objc

%description objc
gcc-objc provides Objective C support for the GNU C compiler (gcc).
Mainly used on systems running NeXTSTEP, Objective C is an
object-oriented derivative of the C language.

Install gcc-objc if you are going to do Objective C development and
you would like to use the gcc compiler.  You'll also need gcc.

%package g77
Summary: Fortran 77 support for gcc
Group: Development/Languages
Requires: gcc = %{version}
Obsoletes: egcs-g77

%description g77
The gcc-g77 package provides support for compiling Fortran 77
programs with the GNU gcc compiler.

You should install gcc-g77 if you are going to do Fortran development
and you would like to use the gcc compiler.  You will also need gcc.

%package -n cpp
Summary: The C Preprocessor.
Group: Development/Languages
Prereq: /sbin/install-info

%description -n cpp
Cpp is the GNU C-Compatible Compiler Preprocessor.
Cpp is a macro processor which is used automatically
by the C compiler to transform your program before actual
compilation. It is called a macro processor because it allows
you to define macros, abbreviations for longer
constructs.

The C preprocessor provides four separate functionalities: the
inclusion of header files (files of declarations that can be
substituted into your program); macro expansion (you can define macros,
and the C preprocessor will replace the macros with their definitions
throughout the program); conditional compilation (using special
preprocessing directives, you can include or exclude parts of the
program according to various conditions); and line control (if you use
a program to combine or rearrange source files into an intermediate
file which is then compiled, you can use line control to inform the
compiler about where each source line originated).

You should install this package if you are a C programmer and you use
macros.

%prep
%setup -q
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch10 -p1
%patch13 -p1
%patch14 -p0
#%patch17 -p1
%patch18 -p1

%build
rm -rf obj-$RPM_ARCH-linux
mkdir obj-$RPM_ARCH-linux
cd obj-$RPM_ARCH-linux
../configure  --prefix=/usr \
	--enable-shared --enable-threads \
	--enable-cpp \
	$RPM_ARCH-redhat-linux

PATH=$PATH:/sbin:/usr/sbin
touch  ../gcc/c-gperf.h
make MAKEINFO="makeinfo --no-split"  bootstrap-lean
make MAKEINFO="makeinfo --no-split"  info

%install
rm -rf $RPM_BUILD_ROOT
cd obj-$RPM_ARCH-linux
PATH=$PATH:/sbin:/usr/sbin
make install \
	prefix=$RPM_BUILD_ROOT%{_prefix} \
	mandir=$RPM_BUILD_ROOT%{_mandir} \
	infodir=$RPM_BUILD_ROOT%{_infodir} \
	MAKEINFO="makeinfo --no-split" 
FULLVER=$($RPM_BUILD_ROOT/usr/bin/gcc --version)
FULLPATH=$(dirname $RPM_BUILD_ROOT/usr/lib/gcc-lib/$RPM_ARCH-*/$FULLVER/cc1)

# fix some things
ln -sf gcc $RPM_BUILD_ROOT%{_prefix}/bin/cc
rm -f $RPM_BUILD_ROOT%{_infodir}/dir
gzip -9 $RPM_BUILD_ROOT%{_infodir}/*.info* 

ln -sf g77.1 $RPM_BUILD_ROOT%{_mandir}/man1/f77.1
ln -sf g77 $RPM_BUILD_ROOT%{_prefix}/bin/f77

mkdir -p $RPM_BUILD_ROOT/lib
ln -sf ../${FULLPATH##$RPM_BUILD_ROOT/}/cpp0 $RPM_BUILD_ROOT/lib/cpp

ln -sf cccp.1 $RPM_BUILD_ROOT%{_mandir}/man1/cpp.1

%clean
rm -rf $RPM_BUILD_ROOT

%post
/sbin/install-info \
	--info-dir=%{_infodir} %{_infodir}/gcc.info.gz

%preun
if [ $1 = 0 ]; then
    /sbin/install-info --delete \
	--info-dir=%{_infodir} %{_infodir}/gcc.info.gz
fi

%post -n libstdc++
if ! grep '^%{_prefix}/%{_lib}$' /etc/ld.so.conf > /dev/null 2>&1; then
	echo %{_prefix}/%{_lib} >>/etc/ld.so.conf
fi
/sbin/ldconfig

%postun -n libstdc++
/sbin/ldconfig

%post objc -p /sbin/ldconfig

%postun objc -p /sbin/ldconfig

%post g77
/sbin/install-info \
	--info-dir=%{_infodir} %{_infodir}/g77.info.gz

%preun g77
if [ $1 = 0 ]; then
    /sbin/install-info --delete \
	--info-dir=%{_infodir} %{_infodir}/g77.info.gz
fi

%post -n cpp
/sbin/install-info \
	--info-dir=%{_infodir} %{_infodir}/cpp.info.gz

%preun -n cpp
if [ $1 = 0 ]; then
    /sbin/install-info --delete \
	--info-dir=%{_infodir} %{_infodir}/cpp.info.gz
fi

/sbin/ldconfig

%files
%defattr(-,root,root)
%doc README* COPYING COPYING.LIB
%dir %{_prefix}/lib/gcc-lib
%dir %{_prefix}/lib/gcc-lib/%{_target_cpu}-redhat-linux/%{version}

%{_prefix}/bin/gcc
%{_prefix}/bin/cc
%{_infodir}/gcc*
%{_prefix}/bin/protoize
%{_prefix}/bin/unprotoize
%{_prefix}/bin/gcov
%{_prefix}/bin/%{_target_cpu}-redhat-linux-gcc
%{_mandir}/man1/gcc.1*

%{_prefix}/lib/gcc-lib/%{_target_cpu}-redhat-linux/%{version}/SYSCALLS.c.X
%{_prefix}/lib/gcc-lib/%{_target_cpu}-redhat-linux/%{version}/cc1
%{_prefix}/lib/gcc-lib/%{_target_cpu}-redhat-linux/%{version}/collect2
%{_prefix}/lib/gcc-lib/%{_target_cpu}-redhat-linux/%{version}/libgcc.a
%{_prefix}/lib/gcc-lib/%{_target_cpu}-redhat-linux/%{version}/specs
%{_prefix}/lib/gcc-lib/%{_target_cpu}-redhat-linux/%{version}/*.o

/usr/%{_target_cpu}-redhat-linux

/usr/lib/gcc-lib/%{_target_cpu}-redhat-linux/%{version}/include/README
/usr/lib/gcc-lib/%{_target_cpu}-redhat-linux/%{version}/include/float.h
/usr/lib/gcc-lib/%{_target_cpu}-redhat-linux/%{version}/include/iso646.h
/usr/lib/gcc-lib/%{_target_cpu}-redhat-linux/%{version}/include/limits.h
/usr/lib/gcc-lib/%{_target_cpu}-redhat-linux/%{version}/include/proto.h
/usr/lib/gcc-lib/%{_target_cpu}-redhat-linux/%{version}/include/stdarg.h
/usr/lib/gcc-lib/%{_target_cpu}-redhat-linux/%{version}/include/stdbool.h
/usr/lib/gcc-lib/%{_target_cpu}-redhat-linux/%{version}/include/stddef.h
/usr/lib/gcc-lib/%{_target_cpu}-redhat-linux/%{version}/include/syslimits.h
/usr/lib/gcc-lib/%{_target_cpu}-redhat-linux/%{version}/include/va-*.h
/usr/lib/gcc-lib/%{_target_cpu}-redhat-linux/%{version}/include/varargs.h

%files -n cpp
%defattr(-,root,root)
/lib/cpp
%{_mandir}/man1/cpp.1*
%{_mandir}/man1/cccp.1*
%{_infodir}/cpp.info*
%{_prefix}/lib/gcc-lib/%{_target_cpu}-redhat-linux/%{version}/cpp*

%files c++
%defattr(-,root,root)
%{_mandir}/man1/g++.1*
%{_prefix}/bin/g++
%{_prefix}/bin/c++
%{_prefix}/bin/c++filt
%{_prefix}/lib/gcc-lib/%{_target_cpu}-redhat-linux/%{version}/cc1plus
%{_prefix}/lib/gcc-lib/%{_target_cpu}-redhat-linux/%{version}/libstdc*
%{_prefix}/lib/gcc-lib/%{_target_cpu}-redhat-linux/%{version}/include/exception
%{_prefix}/lib/gcc-lib/%{_target_cpu}-redhat-linux/%{version}/include/new
%{_prefix}/lib/gcc-lib/%{_target_cpu}-redhat-linux/%{version}/include/typeinfo
%{_prefix}/lib/gcc-lib/%{_target_cpu}-redhat-linux/%{version}/include/new.h
%{_prefix}/include/g+*
%{_prefix}/lib/libstdc++-*

%files -n libstdc++
%defattr(-,root,root)
%{_prefix}/lib/libstdc++-3-libc*.so
%{_prefix}/lib/libstdc++-3-libc*.a

%files objc
%defattr(-,root,root)
%{_prefix}/lib/gcc-lib/%{_target_cpu}-redhat-linux/%{version}/cc1obj
%{_prefix}/lib/gcc-lib/%{_target_cpu}-redhat-linux/%{version}/libobjc.a
%{_prefix}/lib/gcc-lib/%{_target_cpu}-redhat-linux/%{version}/include/objc

%files g77
%defattr(-,root,root)
%{_prefix}/bin/g77
%{_prefix}/bin/f77
%{_infodir}/g77*
%{_prefix}/lib/gcc-lib/%{_target_cpu}-redhat-linux/%{version}/f771
%{_prefix}/lib/gcc-lib/%{_target_cpu}-redhat-linux/%{version}/libg2c.a
%{_mandir}/man1/g77.1*
%{_mandir}/man1/f77.1*
%{_prefix}/lib/gcc-lib/*-redhat-linux/%{version}/include/g2c.h

%changelog
* Tue Mar 19 2002 Phil Knirsch <pknirsch@redhat.com>
- Added latest official IBM gcc patch (gcc-2.95.3-s390-3).

* Fri Feb 08 2002 Phil Knirsch <pknirsch@redhat.com>
- Reenabled glibc224 patch as we are using glibc 2.2.4 now for 7.1

* Thu Jan 31 2002 David Sainty <dsainty@redhat.com> 2.95.3-0.71.2sx
- add in gcc-2.95.2-bogushack-s390x patch to fix cpp compiles

* Thu Jan 31 2002 David Sainty <dsainty@redhat.com>
- disable glibc224 patch - we don't have glibc-2.2.4 on 7.1

* Wed Oct 24 2001 Karsten Hopp <karsten@redhat.de>
- add -undef patch to ignore unsupported flag

* Tue Oct 16 2001 David Sainty <dsainty@redhat.com>
- use 2.95.3 with following patches:
	- s390 and s390-1 and s390-2 (v.recent) IBM patches
	- glibc224 and libio patches

* Sat Dec 09 2000 Florian La Roche <Florian.LaRoche@redhat.de>
- use 2.95.2 with the following patches:
	- current head of cvs
	- S390 patch from IBM: gcc-2.95.2.4
	- spec file is based on the standard Red Hat Linux 7 one plus
	  a version ported from Red Hat Linux 6.2 to S390 by
		- Oliver Paukstadt <opaukstadt@millenux.com>
		- Fritz Elfert <felfert@to.com>

